' *********************************************************
' *-------------------------------------------------------*
' *- mignon game kit                                     -*
' *-                                                     -*
' *- Olaf Val 2003                                       -*
' *- mit freundlicher Untersttzung von Martin Nawrath   -*
' *-                                                     -*
' *- www.olafval.de/mignon                               -*
' *- (www.khm.de/~nawrath)                               -*
' *-------------------------------------------------------*
' *********************************************************


' Pony Prog Settings:

'Security and Configuration Bits

'  internal RC oscillator  8 Mhz
' (x)  BOOTSZ1
' ( )  BOOTSZ0
' (x)  BOOTRST
' (x)  SUTO
' (x)  Cksel3        Cksel 0..3 = 0100 = 8MHz
' ( )  Cksel2
' (x)  Cksel1
' (x)  Cksel0
' ( )  SUT1
' ( )  COPT

' Configurationen =============================================================
Dim F_s As Bit
Dim F_int As Bit
Dim Tics As Word
Dim Mx(5) As Byte
Dim Mxa(5) As Byte
Dim Mrow As Byte At &H100
Dim Mcol As Byte At &H101
Dim Midx As Byte At &H102
Config Timer0 = Timer , Prescale = 256
$crystal = 8000000
'Baud = 19200
' oscillator calibration byte
Osccal = 158                                                ' Internen Oszillator auf 8MHz ziehen
On Timer0 Tm0isr
Enable Interrupts
Enable Timer0

'Dot-Matrix-LED Prots (5x7):
Config Pind.5 = Output                                      ' R7
Config Pinb.2 = Output                                      ' R6
Config Pinb.7 = Output                                      ' R5
Config Pinb.1 = Output                                      ' R4
Config Pinc.4 = Output                                      ' R3
Config Pinc.0 = Output                                      ' R2
Config Pinc.3 = Output                                      ' R1

Config Pind.6 = Output                                      ' C1
Config Pinc.1 = Output                                      ' C2
Config Pinb.0 = Output                                      ' C3
Config Pind.7 = Output                                      ' C4
Config Pinc.2 = Output                                      ' C5

Config Pinb.4 = Output                                      ' Lautsprecher

'Taster:
Config Pind.1 = Input                                       'links
Config Pind.0 = Input                                       'rechts
Set Portd.0
Set Portd.1
Config Pind.2 = Input                                       'oben
Config Pind.3 = Input                                       'unten
Set Portd.2
Set Portd.3
Config Pinb.3 = Input                                       'Funktion A
Config Pinc.5 = Input                                       'Funktion B
Set Portb.3
Set Portc.5
Declare Sub Geschaft
' Configurationen Ende ========================================================


'(
'Intro +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   Mx(1) = 0                                                'alle lschen
   Mx(2) = 0
   Mx(3) = 0
   Mx(4) = 0
   Mx(5) = 0

Wait 1                                                      'watre 1 sec
Mx(1) = &B0001000                                           'Reihe 1 Mitte
Wait 1
Mx(1) = &B0000000                                           'lsche Reihe 1
Mx(2) = &B0001000
Wait 1
Mx(2) = &B0000000
Mx(3) = &B0001000
Wait 1
Mx(3) = &B0000000
Mx(4) = &B0001000
Wait 1
Sound Pinb.4 , 1000 , 100                                   'Sound Lnge, Tonhhe
Sound Pinb.4 , 5000 , 80
Wait 2
Mx(4) = &B0000000
'Intro Ende ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
')

'Game Variablen:::
Dim Tick As Word
Dim Press1 As Bit
Dim Bb1 As Byte
Dim R As Byte
Dim L As Byte
Dim X As Byte
Dim Y As Byte
Dim Xset As Byte
Dim Yset As Byte
Dim Sink As Byte
Dim Wall As Byte
Dim Wallbit(35) As Byte
Dim Wall1 As Byte
Dim Wallx As Byte
Dim Wally As Byte
Dim Cop As Byte
Dim Random As Byte
Dim Z As Byte
Dim Wellrun As Byte
Dim Wellrunx As Byte
Dim Wellx As Byte
Dim Welly As Byte
Dim Wellm As Bit
Dim Wellt As Byte
Dim Wells As Byte                                           'Wellen-speed
Dim Traege As Byte
Dim Score As Byte
X = 4
Y = 3
Wells = 40

'Watre Schleife ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Do
 'Navigation -----------------------------
   Tick = Tick + 1
  If Tick > 1000 Then                                       '1000 Takt(
   Tick = 0

   Mxa(1) = 0                                               'alle lschen
   Mxa(2) = 0
   Mxa(3) = 0
   Mxa(4) = 0
   Mxa(5) = 0


    ' Spielfigur:----------
    If Pinc.5 = 0 Then                                      'Tasten abfrage
     If Press1 = 0 Then
      Y = Y - 1
     End If
     Press1 = 1
     Else
     Press1 = 0
    End If

    Sink = Sink + 1                                         'Sinken
    If Sink > 150 Then
      Sink = 0
      Y = Y + 1
    End If

    If X > 7 Then                                           'Rand
      X = 7
    End If
    If X < 1 Then
      X = 1
    End If
    If Y > 5 Then
      Y = 5
    End If
    If Y < 1 Then
      Y = 1
    End If
    Random = X * 5
    Random = Random - 5
    Random = Random + Y
                                             'Schwimmen
       If Wallbit(random) = 1 Then
          If Traege = 3 Then
             Traege = 0
          End If

          If Traege = 0 Then
            Traege = 1
            Z = Random + 5
            If Z > 35 Then
               Y = Y - 1
               X = X - 1
               Sound Pinb.4 , 70 , 120
            Else
              If Wallbit(z) = 0 Then
                Y = Y - 1
                X = X - 1
                Sound Pinb.4 , 70 , 120
              End If
            End If
          End If

           Random = Random - 1
           If Traege = 2 Then
            If Wallbit(random) = 1 Then
               X = X + 1
               Sound Pinb.4 , 60 , 60
            End If
           End If
          If Wellt = 0 Then
            Traege = Traege + 1
          End If
       Else
          'If Traege = 0 Then
            'Traege = 0
          'End If
       End If


   Xset = X
   Yset = Y
   'If Wellt > 10 Then 'Blink
     Gosub Punktsetzen
   'End If
Wall = Wall + 1                                             'BitWall
If Wall > 32 Then
   Wall = 1
End If

Wellt = Wellt + 1
If Wellt > Wells Then                                       'wellenTIMER
 Wellt = 0

 For Cop = 1 To 30                                          'wellenShift
  Wallbit(cop) = Wallbit(cop + 5)
 Next

 Random = Rnd(50)                                           'wellenGenerator
 If Random < 6 Then
  If Wellrun = 0 Then
   Wellx = Rnd(7)
   Wellrunx = 10
   Welly = Random
   If Random = 5 Then
      Welly = 1
   End If
   Wellm = 0
  End If
 End If

'*(
 If Wellm = 0 Then                                          'wellm = 0 = welle aufbauen
  If Wellx = 6 Then
    Wellrun = Wellrun + 2
  Else
    Wellrunx = Wellrunx + 1
    If Wellrunx >= Wellx Then
      Wellrun = Wellrun + 1
      Wellrunx = 0
    End If
  End If
 Else
  If Wellrun > 0 Then
    If Wellx = 6 Then
      Wellrun = Wellrun - 2
    Else
      Wellrunx = Wellrunx + 1
      If Wellrunx >= Wellx Then
        Wellrun = Wellrun - 1
        Wellrunx = 0
      End If
    End If
  End If
 End If
 If Wellrun >= Welly Then
   Wellm = 1
   Welly = 0
 End If
'*)

 For Z = 31 To 35
    Wallbit(z) = 0
 Next
 If Wellrun > 0 Then
  For Random = 1 To Wellrun
   Z = 36 - Random
   Wallbit(z) = 1
  Next
 End If

End If                                                      'wellenTIMER
  Wall1 = 0
  For Wallx = 1 To 7
   For Wally = 1 To 5
    Wall1 = Wall1 + 1
    If Wallbit(wall1) = 1 Then
      Xset = Wallx
      Yset = Wally
     Gosub Punktsetzen
    End If
  Next
 Next

 'Punktestand
If X = 1 Then                                               'new point
    Gosub Point
End If

Gosub Showponis                                             'show points
Gosub Punktezeigen
If Score > 6 Then
   Gosub Winn
End If

  End If                                                    '1000 Takt)
'Navigation ende -----------------------
Loop
'Warte Schleife Ende +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Winn:
    Wait 1
    Mx(1) = &B1111111
    Wait 1
    Mx(1) = &B0000000
    Mx(2) = &B1111111
    Wait 1
    Mx(2) = &B0000000
    Mx(3) = &B1111111
    Wait 1
    Mx(3) = &B0000000
    Mx(4) = &B1111111
    Wait 3
    Mx(3) = &B00001000
    Wait 1
    Mx(3) = &B00011100
    Wait 1
    Mx(2) = &B00011100
    Mx(3) = &B00111110
    Wait 1
    Mx(1) = &B00011100
    Mx(2) = &B00111110
    Mx(3) = &B00011100
    Wait 1
    Mx(1) = &B00111110
    Mx(2) = &B00011100
    Mx(3) = &B00000000
    Wait 1
    Mx(1) = &B00011100
    Mx(2) = &B00000000
    Wait 1
    Mx(1) = &B00000000
    Wait 3
    Mx(4) = &B0000000
    Mx(5) = &B1111111
    Wait 1
    Mx(5) = &B0000000
    Wait 1
    For Z = 1 To 35
       Wallbit(z) = 0
    Next
    Score = 0
    X = 4
    Y = 3
Return

Showponis:
 If Score > 0 Then                                          'show points
  For Z = 1 To Score
    Xset = Z
    Yset = 1
    Gosub Punktsetzen
  Next
 End If
Return

Point:
    Wait 1
    For Z = 1 To 3
      Mx(y) = &B1000000
      Sound Pinb.4 , 170 , 120
      Waitms 250
      Mx(y) = &B0000000
      Waitms 250
      Sound Pinb.4 , 170 , 120
    Next
    For Random = 1 To 3
      Waitms 350
      Gosub Showponis
      Gosub Punktezeigen
      Sound Pinb.4 , 170 , 160
      Mx(1) = &B0000000
    Next
    Mx(1) = &B1000000
    Sound Pinb.4 , 370 , 160
    X = 4
    Y = 3
    Score = Score + 1
Return


Punktsetzen:
    Bb1 = &B10000000
    R = 8 - Xset
    For L = 1 To R
     Rotate Bb1 , Left , 1
    Next
    Mxa(yset) = Mxa(yset) Or Bb1
Return

Punktezeigen:
    For L = 1 To 5
        Mx(l) = Mxa(l)
    Next
Return




' Maschinensprache ************************************************************
' Treiber fr die LED-Dot-Matrix **********************************************
Wait_us:
Wait_us_50_1:
      nop
      nop
      dec      r18
      brne     Wait_us_50_1
      ret
$end Asm
' Timer0 Interrupt Service Routine  2ms
Tm0isr:                                                     ' Prescaler 8MHz/256 / 63 8 MHz
Set F_int                                                   ' Interrupt Flag
Timer0 = 193                                                ' 256-63= 193 = 2 ms
Incr Tics
$asm
   cbi      Portd,5                                         ' Alle Sieben Row Leitungen auf Null setzen
   cbi      Portb,2
   cbi      Portb,7
   cbi      Portb,1
   cbi      Portc,4
   cbi      Portc,0
   cbi      Portc,3
   cbi      Portd,6                                         ' Alle 5 Column Leitungen auf Null setzen
   cbi      Portc,1
   cbi      Portb,0
   cbi      Portd,7
   cbi      Portc,2
$end Asm
 If Mcol = 32 Then
      Mcol = 1
      Midx = 0
   End If
   Incr Midx
   If Mcol = 0 Then Mcol = 1
   Shift Mcol , Left , 1
$asm
   lds      r16,{mcol}                                      ' Transistoren an Ports D6,C1,B0,D7,C2
Cc1:
   sbrs     r16,1
   rjmp     cc2
   sbi      portd,6
Cc2:
   sbrs     r16,2
   rjmp     cc3
   sbi      portc,1
Cc3:
   sbrs     r16,3
   rjmp     cc4
   sbi      portb,0
Cc4:
   sbrs     r16,4
   rjmp     cc5
   sbi      portd,7
Cc5:
   sbrs     r16,5
   rjmp     ccx
   sbi      portc,2
Ccx:
$end Asm
   Mrow = Mx(midx)
$asm
   lds      r16,{Mrow}                                      ' Sieben Row-Pins einschalten gemaess Bitmuster
Rr1:
   sbrs     r16,0                                           ' in Variable Mrow
   rjmp     rr2
   sbi      portd,5
Rr2:
   sbrs     r16,1
   rjmp     rr3
   sbi      portb,2
Rr3:
   sbrs     r16,2
   rjmp     rr4
   sbi      portb,7
Rr4:
   sbrs     r16,3
   rjmp     rr5
   sbi      portb,1
Rr5:
   sbrs     r16,4
   rjmp     rr6
   sbi      portc,4
Rr6:
   sbrs     r16,5
   rjmp     rr7
   sbi      portc,0
Rr7:
   sbrs     r16,6
   rjmp     rrx
   sbi      portc,3
Rrx:
$end Asm
Return
' Maschinensprache Ende ********************************************************
' Treiber fr die LED-Dot-Matrix Ende ******************************************